<script setup lang="ts">
import Select from '@/components/Select.vue';
import DatePicker from '@/components/DatePicker.vue';
import {
  selectedUid,
  selectedUp3Ulp,
  selectedUlp,
  fetchUid,
  itemsUid,
  itemsUp3,
  itemsUlp
} from './reference';
import { onMounted, ref, watch } from 'vue';

const uidPlaceholder = 'Semua Unit Induk Distribusi/Wilayah'
const up3Placeholder = 'Semua Unit Pelaksanaan Pelayanan Pelanggan'
const ulpPlaceholder = 'Semua Unit Layanan Pelanggan'
const up3 = ref({ id: 0, name: up3Placeholder })
const uid = ref({ id: 0, name: uidPlaceholder })
const ulp = ref({ id: 0, name: ulpPlaceholder })
const emit = defineEmits(['update:filters'])

const data = ref({
  uid: uid.value,
  up3: up3.value,
  ulp: ulp.value,
  periode: ''
})

watch(data.value, (value) => {
  emit('update:filters', value)
})

const setUid = (value: any) => {
  uid.value = value
  selectedUid(value)
  up3.value = { id: 0, name: up3Placeholder }
  data.value.uid = value
}

const setUp3 = (value: any) => {
  up3.value = value
  selectedUp3Ulp(value)
  ulp.value = { id: 0, name: ulpPlaceholder }
  data.value.up3 = value
  console.log(itemsUlp)
}

const setUlp = (value: any) => {
  ulp.value = value
  selectedUlp(value)
  data.value.ulp = value
}

onMounted(() => {
  fetchUid()
  emit('update:filters', data.value)
})
</script>

<template>
  <div class="grid grid-cols-1 gap-4 md:grid-cols-2">
    <div class="flex flex-col flex-1 space-y-2">
      <label class="filter-input-label">Unit Induk Distribusi/Wilayah:</label>

      <Select @update:selected="setUid($event)" :data="itemsUid" :placeholder="uidPlaceholder" />
    </div>

    <div class="flex flex-col flex-1 space-y-2">
      <label class="filter-input-label">Unit Pelaksanaan Pelayanan Pelanggan:</label>

      <Select @update:selected="setUp3($event)" :data="itemsUp3" :selected="up3" :placeholder="up3Placeholder" />
    </div>

    <div class="flex flex-col flex-1 space-y-2">
      <label class="filter-input-label">Unit Layanan Pelanggan:</label>

      <Select @update:selected="setUlp($event)" :data="itemsUlp" :selected="ulp" :placeholder="ulpPlaceholder" />
    </div>

    <div class="flex flex-col flex-1 space-y-2">
      <label class="filter-input-label">Periode Tanggal:</label>

      <DatePicker @update:date-value="(value) => (data.periode = value)" />
    </div>
  </div>

</template>
